// --------------------------------------------------------------------
// Copyright (c) 2009 by Terasic Technologies Inc. 
// --------------------------------------------------------------------
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// --------------------------------------------------------------------
//           
//                     Terasic Technologies Inc
//                     356 Fu-Shin E. Rd Sec. 1. JhuBei City,
//                     HsinChu County, Taiwan
//                     302
//
//                     web: http://www.terasic.com/
//                     email: support@terasic.com
//
// --------------------------------------------------------------------
//
// Major Functions:	Ethernet Card for cycloneIII 3c25 start board
//
// --------------------------------------------------------------------
//
// Revision History :
// --------------------------------------------------------------------
//   Ver  :| Author            :| Mod. Date :| Changes Made:
//   V1.0 :| Eric Chen         :| 09/05/04  :| Initial Revision
// --------------------------------------------------------------------
`default_nettype none
`define	NET0

module QB3_NET_TOP(

	// Global clock & reset
	CLK50,
	RESET_N,

//	// Push Button
//	BUTTON, 
//
	// LED
	LED, 

	// JTAG UART Chain
	LINK_D0,         
	LINK_D1,         
	LINK_D2, 

	// Flash and SRAM Share Bus
	FLASH_SRAM_A,		//
	FLASH_SRAM_DQ,		//
	
	// Flash Memory
	FLASH_CLK,       
	FLASH_ADV_N,     
	FLASH_CE_N,			//
	FLASH_OE_N,			//
	FLASH_RESET_N,		//
	FLASH_WAIT,
	FLASH_WE_N,			//
	// SRAM Memory
	SRAM_ADSC_N,     
	SRAM_CE1_N,      
	SRAM_CLK,        
	SRAM_OE_N,       
	SRAM_WE_N,                      
	SRAM_BE_N,    

	// DDR Memory
	mem_addr,
	mem_dq,
	mem_ba,
	mem_cke,
	mem_clk_n,
	mem_clk,
	mem_cs_n,
	mem_ras_n,
	mem_cas_n,
	mem_we_n,
	mem_dm,
	mem_dqs,


	// Ethernet BOARD Pin Name
	HSMC_SCL,
	HSMC_SDA,
	NET0_GTX_CLK,
	NET0_INTN,
	NET0_LINK1000,
	NET0_MDC,
	NET0_MDIO,
	NET0_RESETN,
	NET0_RX_CLK,
	NET0_RX_COL,
	NET0_RX_CRS,
	NET0_RX_DV,
	NET0_RX_D,
	NET0_RX_ER,
	NET0_S_CLKN,
	NET0_S_CLKP,
	NET0_S_RX_N,
	NET0_S_RX_P,
	NET0_S_TX_N,
	NET0_S_TX_P,
	NET0_TX_CLK,
	NET0_TX_D,
	NET0_TX_EN,
	NET0_TX_ER,
	NET1_GTX_CLK,
	NET1_INTN,
	NET1_LINK1000,
	NET1_MDC,
	NET1_MDIO,
	NET1_RESETN,
	NET1_RX_CLK,
	NET1_RX_COL,
	NET1_RX_CRS,
	NET1_RX_DV,
	NET1_RX_D,
	NET1_RX_ER,
	NET1_S_CLKN,
	NET1_S_CLKP,
	NET1_S_RX_N,
	NET1_S_RX_P,
	NET1_S_TX_N,
	NET1_S_TX_P,
	NET1_TX_CLK,
	NET1_TX_D,
	NET1_TX_EN,
	NET1_TX_ER
);

//=============================================================================
// 
//=============================================================================
// Global clock & reset
input			CLK50;
input			RESET_N;

//// Push Button
//input	[4:1]	BUTTON;
//
// LED
output	[4:1]	LED;

// JTAG UART Chain
input			LINK_D0;
input			LINK_D1;
input			LINK_D2;

// Flash and SRAM Share Bus
output	[23:0]	FLASH_SRAM_A;               
inout	   [31:0]	FLASH_SRAM_DQ;       
     
// Flash Memory
output			FLASH_CLK;       
output			FLASH_ADV_N;     
output			FLASH_CE_N;      
output			FLASH_OE_N;      
output			FLASH_RESET_N;   
input		   	FLASH_WAIT;      
output			FLASH_WE_N;      
// SRAM Memory
output			SRAM_ADSC_N;     
output			SRAM_CE1_N;      
output			SRAM_CLK;        
output			SRAM_OE_N;       
output			SRAM_WE_N;                      
output	[3:0]	SRAM_BE_N;    

// DDR Memory
output	[12:0]	mem_addr;
inout 	[15:0]	mem_dq;
output	[1:0]	mem_ba;
output			mem_cke;
output			mem_ras_n;
output			mem_we_n;
output			mem_cas_n;
inout			   mem_clk_n;
inout			   mem_clk;
output			mem_cs_n;
output	[1:0]	mem_dm;
inout	   [1:0] mem_dqs;


// Ethernet BOARD Pin Declare
output			HSMC_SCL;
inout			HSMC_SDA;
output			NET0_GTX_CLK;
output			NET0_INTN;
input			NET0_LINK1000;
output			NET0_MDC;
inout			NET0_MDIO;
output			NET0_RESETN;
input			NET0_RX_CLK;
input			NET0_RX_COL;
input			NET0_RX_CRS;
input			NET0_RX_DV;
input	[7:0]	NET0_RX_D;
input			NET0_RX_ER;
input			NET0_S_CLKN;
input			NET0_S_CLKP;
input			NET0_S_RX_N;
input			NET0_S_RX_P;
output			NET0_S_TX_N;
output			NET0_S_TX_P;
input			NET0_TX_CLK;
output	[7:0]	NET0_TX_D;
output			NET0_TX_EN;
output			NET0_TX_ER;
output			NET1_GTX_CLK;
output			NET1_INTN;
input			NET1_LINK1000;
output			NET1_MDC;
inout			NET1_MDIO;
output			NET1_RESETN;
input			NET1_RX_CLK;
input			NET1_RX_COL;
input			NET1_RX_CRS;
input			NET1_RX_DV;
input	[7:0]	NET1_RX_D;
input			NET1_RX_ER;
input			NET1_S_CLKN;
input			NET1_S_CLKP;
input			NET1_S_RX_N;
input			NET1_S_RX_P;
output			NET1_S_TX_N;
output			NET1_S_TX_P;
input			NET1_TX_CLK;
output	[7:0]	NET1_TX_D;
output			NET1_TX_EN;
output			NET1_TX_ER;



//=============================================================================
// REG/WIRE declarations
//=============================================================================
wire			global_reset_n;
wire			CLK_125MHz;
reg				LEDR_dummy;
//===== ethernet =====
wire			enet_resetn;
  // clock
wire			tx_clk_ref125;
wire			tx_clk_phy125;
wire			tx_clk_mac;
wire			enet_gtx_clk;
wire			enet_tx_clk;
wire			enet_rx_clk;

  // Management Interface and Interrupt
wire			enet_mdc;
wire			enet_mdio_in;
wire			enet_mdio_oen;
wire			enet_mdio_out;

  // SOPC control signal
wire			ena_10_from_the_tse_mac;
wire			eth_mode_from_the_tse_mac;
wire			set_1000_to_the_tse_mac;
wire			set_10_to_the_tse_mac;

  // local MUX signal
wire			m_rx_col;
wire			m_rx_crs;
wire	[3:0]	m_rx_d;
wire			m_rx_dv;
wire			m_rx_err;
wire	[3:0]	m_tx_d;
wire			m_tx_en;
wire			m_tx_err;
wire	[7:0]	gm_rx_d;
wire			gm_rx_dv;
wire			gm_rx_err;
wire	[7:0]	gm_tx_d;
wire			gm_tx_en;
wire			gm_tx_err;

//wire			global_reset_n;
//wire			enet_resetn;
//wire			CLK_125MHz;
////===== ethernet =====
//wire			enet_tx_clk_mac;
//wire			enet_tx_clk_phy;
//wire			enet_rx_clk_270deg;
//
//wire			enet_gtx_clk;
//wire			enet_rx_clk;
//
//wire			NET0_mdio_in;
//wire			NET0_mdio_oen;
//wire			NET0_mdio_out;
//
//wire			NET1_mdio_in;
//wire			NET1_mdio_oen;
//wire			NET1_mdio_out;
//
//wire			ena_10_from_the_tse_mac;
//wire			eth_mode_from_the_tse_mac;
//wire			set_1000_to_the_tse_mac;
//wire			set_10_to_the_tse_mac;
//=============================================================================
// Structural coding
//=============================================================================
//assign 	DDR_DQ = 16'hzzzz; 
//assign	DDR_DQS0 = 1'hz;        
//assign	DDR_DQS1 = 1'hz;

// assign FLASH signal
assign	FLASH_RESET_N = global_reset_n;
assign	FLASH_CLK = 1'b1;
assign	FLASH_ADV_N = 1'b0;
//assign	FLASH_SRAM_DQ = 32'hzzzz_zzzz;

assign HSMC_SDA = 1'bz;
// ===== ethernet clock =====
// ===== ethernet signal =====
assign NET0_RESETN		= enet_resetn;
assign NET1_RESETN		= enet_resetn;

`ifdef NET0
assign enet_rx_clk		= NET0_RX_CLK;
assign enet_tx_clk		= NET0_TX_CLK;
assign NET0_GTX_CLK		= enet_gtx_clk;
assign NET0_MDC			= enet_mdc;

`else
assign enet_rx_clk		= NET1_RX_CLK;
assign enet_tx_clk		= NET1_TX_CLK;
assign NET1_GTX_CLK		= enet_gtx_clk;
assign NET1_MDC			= enet_mdc;

`endif

// ===== SOPC control signal defing
assign set_1000_to_the_tse_mac	= 1'b0;
assign set_10_to_the_tse_mac	= 1'b0;


// Ethernet TX PLL
enet_tx_clk_pll enet_tx_clk_pll
(
		.inclk0(CLK50),
		.c0(tx_clk_ref125),
		.c1(tx_clk_phy125)
);


gen_reset_n	system_gen_reset_n (
		.tx_clk(CLK50),
		.reset_n_in(RESET_N),
		.reset_n_out(global_reset_n)
		);

gen_reset_n	net_gen_reset_n(
		.tx_clk(CLK50),
		.reset_n_in(RESET_N),
		.reset_n_out(enet_resetn)
);


QB3_SOPC QB3_SOPC_inst
	(
		// 1) global signals:
//		.clk_cpu                              (clk_cpu),
		.clk_osc                              (CLK50),
//		.clk_peripheral                       (clk_peripheral),
		.clk_ssram                            (SRAM_CLK),
//		.clk_vga                              (clk_vga),
//		.clk_video                            (clk_video),
//		.altmemddr_aux_full_rate_clk_out      (altmemddr_aux_full_rate_clk_out),
//		.altmemddr_aux_half_rate_clk_out      (altmemddr_aux_half_rate_clk_out),
//		.altmemddr_phy_clk_out                (altmemddr_phy_clk_out),
		.reset_n                              (global_reset_n),


//		// the_altmemddr
		.global_reset_n_to_the_altmemddr(global_reset_n),
//		.local_init_done_from_the_altmemddr(),
//		.local_refresh_ack_from_the_altmemddr(),
//		.local_wdata_req_from_the_altmemddr(),
		.mem_addr_from_the_altmemddr(mem_addr),
		.mem_ba_from_the_altmemddr(mem_ba),
		.mem_cas_n_from_the_altmemddr(mem_cas_n),
		.mem_cke_from_the_altmemddr(mem_cke),
		.mem_clk_n_to_and_from_the_altmemddr(mem_clk_n),
		.mem_clk_to_and_from_the_altmemddr(mem_clk),
		.mem_cs_n_from_the_altmemddr(mem_cs_n),
		.mem_dm_from_the_altmemddr(mem_dm),
		.mem_dq_to_and_from_the_altmemddr(mem_dq),
		.mem_dqs_to_and_from_the_altmemddr(mem_dqs),
		.mem_ras_n_from_the_altmemddr(mem_ras_n),
		.mem_we_n_from_the_altmemddr(mem_we_n),
//		reset_phy_clk_n_from_the_altmemddr(),


		// the_flash_ssram_tristate_bridge_avalon_slave
		.adsc_n_to_the_ssram(SRAM_ADSC_N),
		.bw_n_to_the_ssram(SRAM_BE_N),
		.bwe_n_to_the_ssram(SRAM_WE_N),
		.chipenable1_n_to_the_ssram(SRAM_CE1_N),
		.flash_ssram_tristate_bridge_address(FLASH_SRAM_A),
		.flash_ssram_tristate_bridge_data(FLASH_SRAM_DQ),
		.outputenable_n_to_the_ssram(SRAM_OE_N),
		.read_n_to_the_ext_flash(FLASH_OE_N),
		.select_n_to_the_ext_flash(FLASH_CE_N),
		.write_n_to_the_ext_flash(FLASH_WE_N),

		// the_tse_mac (MII / GMII)
		.ena_10_from_the_tse_mac(ena_10_from_the_tse_mac),
		.eth_mode_from_the_tse_mac(eth_mode_from_the_tse_mac),
		.gm_rx_d_to_the_tse_mac(gm_rx_d),
		.gm_rx_dv_to_the_tse_mac(gm_rx_dv),
		.gm_rx_err_to_the_tse_mac(gm_rx_err),
		.gm_tx_d_from_the_tse_mac(gm_tx_d),
		.gm_tx_en_from_the_tse_mac(gm_tx_en),
		.gm_tx_err_from_the_tse_mac(gm_tx_err),
		.m_rx_col_to_the_tse_mac(m_rx_col),
		.m_rx_crs_to_the_tse_mac(m_rx_crs),
		.m_rx_d_to_the_tse_mac(m_rx_d),
		.m_rx_en_to_the_tse_mac(m_rx_dv),
		.m_rx_err_to_the_tse_mac(m_rx_err),
		.m_tx_d_from_the_tse_mac(m_tx_d),
		.m_tx_en_from_the_tse_mac(m_tx_en),
		.m_tx_err_from_the_tse_mac(m_tx_err),
		.mdc_from_the_tse_mac(enet_mdc),
		.mdio_in_to_the_tse_mac(enet_mdio_in),
		.mdio_oen_from_the_tse_mac(enet_mdio_oen),
		.mdio_out_from_the_tse_mac(enet_mdio_out),
		.rx_clk_to_the_tse_mac(enet_rx_clk),
		.set_1000_to_the_tse_mac(set_1000_to_the_tse_mac),
		.set_10_to_the_tse_mac(set_10_to_the_tse_mac),
		.tx_clk_to_the_tse_mac(tx_clk_mac),

//		// the_pio_button
//		.in_port_to_the_pio_button(BUTTON),


		// the_pio_led
		.out_port_from_the_pio_led(LED)


	);

`ifdef	NET0
GMII_MII_MUX INST_MUX(
					//--- PHY Interface
					.reset_rx_clk_n(enet_resetn),
					.phy_rx_clk(enet_rx_clk),
					.phy_rx_col(NET0_RX_COL),
					.phy_rx_crs(NET0_RX_CRS),
					.phy_rx_d(NET0_RX_D),
					.phy_rx_dv(NET0_RX_DV),
					.phy_rx_err(NET0_RX_ER),
					.reset_tx_clk_n(enet_resetn),
					.tx_clk_ref125(tx_clk_ref125),
					.tx_clk_phy125(tx_clk_phy125),
					.tx_clk_mac(tx_clk_mac),
					.tx_clk(enet_tx_clk),
					.phy_gtx_clk(enet_gtx_clk),
					.phy_tx_d(NET0_TX_D),
					.phy_tx_en(NET0_TX_EN),
					.phy_tx_err(NET0_TX_ER),
					.phy_mdio(NET0_MDIO),
					//--- Local MII Interface
					.m_rx_col(m_rx_col),
					.m_rx_crs(m_rx_crs),
					.m_rx_d(m_rx_d),
					.m_rx_dv(m_rx_dv),
					.m_rx_err(m_rx_err),
					.m_tx_d(m_tx_d),
					.m_tx_en(m_tx_en),
					.m_tx_err(m_tx_err),
					//--- Local GMII Interface
					.gm_rx_d(gm_rx_d),
					.gm_rx_dv(gm_rx_dv),
					.gm_rx_err(gm_rx_err),
					.gm_tx_d(gm_tx_d),
					.gm_tx_en(gm_tx_en),
					.gm_tx_err(gm_tx_err),
					//--- 
					.eth_mode(eth_mode_from_the_tse_mac),
					.mdio_in(enet_mdio_in),
					.mdio_oen(enet_mdio_oen),
					.mdio_out(enet_mdio_out)
					);
`else
GMII_MII_MUX INST_MUX(
					//--- PHY Interface
					.reset_rx_clk_n(enet_resetn),
					.phy_rx_clk(enet_rx_clk),
					.phy_rx_col(NET1_RX_COL),
					.phy_rx_crs(NET1_RX_CRS),
					.phy_rx_d(NET1_RX_D),
					.phy_rx_dv(NET1_RX_DV),
					.phy_rx_err(NET1_RX_ER),
					.reset_tx_clk_n(enet_resetn),
					.tx_clk_ref125(tx_clk_ref125),
					.tx_clk_phy125(tx_clk_phy125),
					.tx_clk_mac(tx_clk_mac),
					.tx_clk(enet_tx_clk),
					.phy_gtx_clk(enet_gtx_clk),
					.phy_tx_d(NET1_TX_D),
					.phy_tx_en(NET1_TX_EN),
					.phy_tx_err(NET1_TX_ER),
					.phy_mdio(NET1_MDIO),
					//--- Local MII Interface
					.m_rx_col(m_rx_col),
					.m_rx_crs(m_rx_crs),
					.m_rx_d(m_rx_d),
					.m_rx_dv(m_rx_dv),
					.m_rx_err(m_rx_err),
					.m_tx_d(m_tx_d),
					.m_tx_en(m_tx_en),
					.m_tx_err(m_tx_err),
					//--- Local GMII Interface
					.gm_rx_d(gm_rx_d),
					.gm_rx_dv(gm_rx_dv),
					.gm_rx_err(gm_rx_err),
					.gm_tx_d(gm_tx_d),
					.gm_tx_en(gm_tx_en),
					.gm_tx_err(gm_tx_err),
					//--- 
					.eth_mode(eth_mode_from_the_tse_mac),
					.mdio_in(enet_mdio_in),
					.mdio_oen(enet_mdio_oen),
					.mdio_out(enet_mdio_out)
					);
`endif


endmodule
